Package org.apache.lucene.index

## Class CodecReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.index.LeafReader
    - - org.apache.lucene.index.CodecReader

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`
  Direct Known Subclasses:
    `FilterCodecReader`, `SegmentReader`

      public abstract class CodecReader
      extends LeafReader

  LeafReader implemented by codec APIs.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.CacheHelper, IndexReader.CacheKey, IndexReader.ClosedListener`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `CodecReader()` | Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `checkIntegrity()` | Checks consistency of this reader.
    `protected void` | `doClose()` | Implements close.
    `void` | `document​(int docID, StoredFieldVisitor visitor)` | Deprecated.
    `BinaryDocValues` | `getBinaryDocValues​(String field)` | Returns `BinaryDocValues` for this field, or null if no binary doc values were indexed for this field.
    `ByteVectorValues` | `getByteVectorValues​(String field)` | Returns `ByteVectorValues` for this field, or null if no `ByteVectorValues` were indexed.
    `abstract DocValuesProducer` | `getDocValuesReader()` | Expert: retrieve underlying DocValuesProducer
    `abstract StoredFieldsReader` | `getFieldsReader()` | Expert: retrieve underlying StoredFieldsReader
    `FloatVectorValues` | `getFloatVectorValues​(String field)` | Returns `FloatVectorValues` for this field, or null if no `FloatVectorValues` were indexed.
    `abstract NormsProducer` | `getNormsReader()` | Expert: retrieve underlying NormsProducer
    `NumericDocValues` | `getNormValues​(String field)` | Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
    `NumericDocValues` | `getNumericDocValues​(String field)` | Returns `NumericDocValues` for this field, or null if no numeric doc values were indexed for this field.
    `abstract PointsReader` | `getPointsReader()` | Expert: retrieve underlying PointsReader
    `PointValues` | `getPointValues​(String field)` | Returns the `PointValues` used for numeric or spatial searches for the given field, or null if there are no point fields.
    `abstract FieldsProducer` | `getPostingsReader()` | Expert: retrieve underlying FieldsProducer
    `SortedDocValues` | `getSortedDocValues​(String field)` | Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
    `SortedNumericDocValues` | `getSortedNumericDocValues​(String field)` | Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field.
    `SortedSetDocValues` | `getSortedSetDocValues​(String field)` | Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
    `Fields` | `getTermVectors​(int docID)` | Deprecated.
    `abstract TermVectorsReader` | `getTermVectorsReader()` | Expert: retrieve underlying TermVectorsReader
    `abstract KnnVectorsReader` | `getVectorReader()` | Expert: retrieve underlying VectorReader
    `void` | `searchNearestVectors​(String field, byte[] target, KnnCollector knnCollector, Bits acceptDocs)` | Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
    `void` | `searchNearestVectors​(String field, float[] target, KnnCollector knnCollector, Bits acceptDocs)` | Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function.
    `StoredFields` | `storedFields()` | Returns a `StoredFields` reader for the stored fields of this index.
    `Terms` | `terms​(String field)` | Returns the `Terms` index for this field, or null if it has none.
    `TermVectors` | `termVectors()` | Returns a `TermVectors` reader for the term vectors of this index.

    - ### Methods inherited from class org.apache.lucene.index.LeafReader

      `docFreq, getContext, getCoreCacheHelper, getDocCount, getFieldInfos, getLiveDocs, getMetaData, getSumDocFreq, getSumTotalTermFreq, postings, postings, searchNearestVectors, searchNearestVectors, totalTermFreq`

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `close, decRef, document, document, ensureOpen, equals, getReaderCacheHelper, getRefCount, getTermVector, hasDeletions, hashCode, incRef, leaves, maxDoc, notifyReaderClosedListeners, numDeletedDocs, numDocs, registerParentReader, tryIncRef`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CodecReader

          protected CodecReader()

      Sole constructor. (For invocation by subclass constructors, typically implicit.)

  - ### Method Detail

    - #### getFieldsReader

          public abstract StoredFieldsReader getFieldsReader()

      Expert: retrieve underlying StoredFieldsReader
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getTermVectorsReader

          public abstract TermVectorsReader getTermVectorsReader()

      Expert: retrieve underlying TermVectorsReader
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getNormsReader

          public abstract NormsProducer getNormsReader()

      Expert: retrieve underlying NormsProducer
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getDocValuesReader

          public abstract DocValuesProducer getDocValuesReader()

      Expert: retrieve underlying DocValuesProducer
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getPostingsReader

          public abstract FieldsProducer getPostingsReader()

      Expert: retrieve underlying FieldsProducer
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getPointsReader

          public abstract PointsReader getPointsReader()

      Expert: retrieve underlying PointsReader
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### getVectorReader

          public abstract KnnVectorsReader getVectorReader()

      Expert: retrieve underlying VectorReader
      NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

    - #### document

          @Deprecated
          public void document​(int docID,
                               StoredFieldVisitor visitor)
                        throws IOException

      Deprecated.
      Description copied from class: `IndexReader`
      Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.
      Specified by:
        `document` in class `IndexReader`
      Throws:
        `IOException`

    - #### getTermVectors

          @Deprecated
          public Fields getTermVectors​(int docID)
                                throws IOException

      Deprecated.
      Description copied from class: `IndexReader`
      Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).
      Specified by:
        `getTermVectors` in class `IndexReader`
      Throws:
        `IOException`

    - #### storedFields

          public final StoredFields storedFields()
                                          throws IOException

      Description copied from class: `IndexReader`
      Returns a `StoredFields` reader for the stored fields of this index.

      This call never returns `null`, even if no stored fields were indexed. The returned instance should only be used by a single thread.

      Example:

           TopDocs hits = searcher.search(query, 10);
           StoredFields storedFields = reader.storedFields();
           for (ScoreDoc hit : hits.scoreDocs) {
             Document doc = storedFields.document(hit.doc);
           }

      Specified by:
        `storedFields` in class `IndexReader`
      Throws:
        `IOException` - If there is a low-level IO error

    - #### termVectors

          public final TermVectors termVectors()
                                        throws IOException

      Description copied from class: `IndexReader`
      Returns a `TermVectors` reader for the term vectors of this index.

      This call never returns `null`, even if no term vectors were indexed. The returned instance should only be used by a single thread.

      Example:

           TopDocs hits = searcher.search(query, 10);
           TermVectors termVectors = reader.termVectors();
           for (ScoreDoc hit : hits.scoreDocs) {
             Fields vector = termVectors.get(hit.doc);
           }

      Specified by:
        `termVectors` in class `IndexReader`
      Throws:
        `IOException` - If there is a low-level IO error

    - #### terms

          public final Terms terms​(String field)
                            throws IOException

      Description copied from class: `LeafReader`
      Returns the `Terms` index for this field, or null if it has none.
      Specified by:
        `terms` in class `LeafReader`
      Throws:
        `IOException`

    - #### getNumericDocValues

          public final NumericDocValues getNumericDocValues​(String field)
                                                     throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` for this field, or null if no numeric doc values were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getBinaryDocValues

          public final BinaryDocValues getBinaryDocValues​(String field)
                                                   throws IOException

      Description copied from class: `LeafReader`
      Returns `BinaryDocValues` for this field, or null if no binary doc values were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getBinaryDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedDocValues

          public final SortedDocValues getSortedDocValues​(String field)
                                                   throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedNumericDocValues

          public final SortedNumericDocValues getSortedNumericDocValues​(String field)
                                                                 throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedNumericDocValues` for this field, or null if no `SortedNumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedNumericDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getSortedSetDocValues

          public final SortedSetDocValues getSortedSetDocValues​(String field)
                                                         throws IOException

      Description copied from class: `LeafReader`
      Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.
      Specified by:
        `getSortedSetDocValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getNormValues

          public final NumericDocValues getNormValues​(String field)
                                               throws IOException

      Description copied from class: `LeafReader`
      Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getNormValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getPointValues

          public final PointValues getPointValues​(String field)
                                           throws IOException

      Description copied from class: `LeafReader`
      Returns the `PointValues` used for numeric or spatial searches for the given field, or null if there are no point fields.
      Specified by:
        `getPointValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getFloatVectorValues

          public final FloatVectorValues getFloatVectorValues​(String field)
                                                       throws IOException

      Description copied from class: `LeafReader`
      Returns `FloatVectorValues` for this field, or null if no `FloatVectorValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getFloatVectorValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### getByteVectorValues

          public final ByteVectorValues getByteVectorValues​(String field)
                                                     throws IOException

      Description copied from class: `LeafReader`
      Returns `ByteVectorValues` for this field, or null if no `ByteVectorValues` were indexed. The returned instance should only be used by a single thread.
      Specified by:
        `getByteVectorValues` in class `LeafReader`
      Throws:
        `IOException`

    - #### searchNearestVectors

          public final void searchNearestVectors​(String field,
                                                 float[] target,
                                                 KnnCollector knnCollector,
                                                 Bits acceptDocs)
                                          throws IOException

      Description copied from class: `LeafReader`
      Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

      The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

      The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

      The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

      Specified by:
        `searchNearestVectors` in class `LeafReader`
      Parameters:
        `field` - the vector field to search
        `target` - the vector-valued query
        `knnCollector` - collector with settings for gathering the vector results.
        `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
      Throws:
        `IOException`

    - #### searchNearestVectors

          public final void searchNearestVectors​(String field,
                                                 byte[] target,
                                                 KnnCollector knnCollector,
                                                 Bits acceptDocs)
                                          throws IOException

      Description copied from class: `LeafReader`
      Return the k nearest neighbor documents as determined by comparison of their vector values for this field, to the given vector, by the field's similarity function. The score of each document is derived from the vector similarity in a way that ensures scores are positive and that a larger score corresponds to a higher ranking.

      The search is allowed to be approximate, meaning the results are not guaranteed to be the true k closest neighbors. For large values of k (for example when k is close to the total number of documents), the search may also retrieve fewer than k documents.

      The returned `TopDocs` will contain a `ScoreDoc` for each nearest neighbor, in order of their similarity to the query vector (decreasing scores). The `TotalHits` contains the number of documents visited during the search. If the search stopped early because it hit `visitedLimit`, it is indicated through the relation `TotalHits.Relation.GREATER_THAN_OR_EQUAL_TO`.

      The behavior is undefined if the given field doesn't have KNN vectors enabled on its `FieldInfo`. The return value is never `null`.

      Specified by:
        `searchNearestVectors` in class `LeafReader`
      Parameters:
        `field` - the vector field to search
        `target` - the vector-valued query
        `knnCollector` - collector with settings for gathering the vector results.
        `acceptDocs` - `Bits` that represents the allowed documents to match, or `null` if they are all allowed to match.
      Throws:
        `IOException`

    - #### doClose

          protected void doClose()
                          throws IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `IOException`

    - #### checkIntegrity

          public void checkIntegrity()
                              throws IOException

      Description copied from class: `LeafReader`
      Checks consistency of this reader.

      Note that this may be costly in terms of I/O, e.g. may involve computing a checksum value against large data files.

      Specified by:
        `checkIntegrity` in class `LeafReader`
      Throws:
        `IOException`